unit schPresupuestosClienteClient_Intf;

interface

uses
  Classes, DB, schBase_Intf, SysUtils, uROClasses, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_ListaAnosPresupuestos = '{B4D25BFF-BFAC-4141-925F-82DC23A4D3A2}';
  RID_PresupuestosCliente = '{BAEC8917-A7DC-4606-AE7E-B8B8748290B1}';
  RID_PresupuestosCliente_Detalles = '{C1C9402A-CDC5-4B77-BE8A-5907A6423EEC}';

  { Data table names }
  nme_ListaAnosPresupuestos = 'ListaAnosPresupuestos';
  nme_PresupuestosCliente = 'PresupuestosCliente';
  nme_PresupuestosCliente_Detalles = 'PresupuestosCliente_Detalles';

  { ListaAnosPresupuestos fields }
  fld_ListaAnosPresupuestosANO = 'ANO';

  { ListaAnosPresupuestos field indexes }
  idx_ListaAnosPresupuestosANO = 0;

  { PresupuestosCliente fields }
  fld_PresupuestosClienteID = 'ID';
  fld_PresupuestosClienteID_EMPRESA = 'ID_EMPRESA';
  fld_PresupuestosClienteFECHA_PRESUPUESTO = 'FECHA_PRESUPUESTO';
  fld_PresupuestosClienteFECHA_DECISION = 'FECHA_DECISION';
  fld_PresupuestosClienteREFERENCIA = 'REFERENCIA';
  fld_PresupuestosClienteREFERENCIA_AUX = 'REFERENCIA_AUX';
  fld_PresupuestosClienteSITUACION = 'SITUACION';
  fld_PresupuestosClienteID_CLIENTE = 'ID_CLIENTE';
  fld_PresupuestosClienteID_DIRECCION = 'ID_DIRECCION';
  fld_PresupuestosClienteNIF_CIF = 'NIF_CIF';
  fld_PresupuestosClienteNOMBRE = 'NOMBRE';
  fld_PresupuestosClienteREFERENCIA_CLIENTE = 'REFERENCIA_CLIENTE';
  fld_PresupuestosClienteCLIENTE_FINAL = 'CLIENTE_FINAL';
  fld_PresupuestosClientePORTADA = 'PORTADA';
  fld_PresupuestosClienteMEMORIA = 'MEMORIA';
  fld_PresupuestosClienteOBSERVACIONES = 'OBSERVACIONES';
  fld_PresupuestosClienteINCIDENCIAS = 'INCIDENCIAS';
  fld_PresupuestosClienteINCIDENCIAS_ACTIVAS = 'INCIDENCIAS_ACTIVAS';
  fld_PresupuestosClienteFECHA_ALTA = 'FECHA_ALTA';
  fld_PresupuestosClienteFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_PresupuestosClienteUSUARIO = 'USUARIO';
  fld_PresupuestosClienteIMPORTE_NETO = 'IMPORTE_NETO';
  fld_PresupuestosClienteIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_PresupuestosClienteDESCUENTO = 'DESCUENTO';
  fld_PresupuestosClienteIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_PresupuestosClienteBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_PresupuestosClienteIVA = 'IVA';
  fld_PresupuestosClienteIMPORTE_IVA = 'IMPORTE_IVA';
  fld_PresupuestosClienteIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_PresupuestosClienteID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_PresupuestosClienteID_FACTURA = 'ID_FACTURA';
  fld_PresupuestosClienteFACTURA = 'FACTURA';
  fld_PresupuestosClientePERSONA_CONTACTO = 'PERSONA_CONTACTO';
  fld_PresupuestosClienteDESCRIPCION_BONIFICACION = 'DESCRIPCION_BONIFICACION';
  fld_PresupuestosClienteIMPORTE_BONIFICACION = 'IMPORTE_BONIFICACION';

  { PresupuestosCliente field indexes }
  idx_PresupuestosClienteID = 0;
  idx_PresupuestosClienteID_EMPRESA = 1;
  idx_PresupuestosClienteFECHA_PRESUPUESTO = 2;
  idx_PresupuestosClienteFECHA_DECISION = 3;
  idx_PresupuestosClienteREFERENCIA = 4;
  idx_PresupuestosClienteREFERENCIA_AUX = 5;
  idx_PresupuestosClienteSITUACION = 6;
  idx_PresupuestosClienteID_CLIENTE = 7;
  idx_PresupuestosClienteID_DIRECCION = 8;
  idx_PresupuestosClienteNIF_CIF = 9;
  idx_PresupuestosClienteNOMBRE = 10;
  idx_PresupuestosClienteREFERENCIA_CLIENTE = 11;
  idx_PresupuestosClienteCLIENTE_FINAL = 12;
  idx_PresupuestosClientePORTADA = 13;
  idx_PresupuestosClienteMEMORIA = 14;
  idx_PresupuestosClienteOBSERVACIONES = 15;
  idx_PresupuestosClienteINCIDENCIAS = 16;
  idx_PresupuestosClienteINCIDENCIAS_ACTIVAS = 17;
  idx_PresupuestosClienteFECHA_ALTA = 18;
  idx_PresupuestosClienteFECHA_MODIFICACION = 19;
  idx_PresupuestosClienteUSUARIO = 20;
  idx_PresupuestosClienteIMPORTE_NETO = 21;
  idx_PresupuestosClienteIMPORTE_PORTE = 22;
  idx_PresupuestosClienteDESCUENTO = 23;
  idx_PresupuestosClienteIMPORTE_DESCUENTO = 24;
  idx_PresupuestosClienteBASE_IMPONIBLE = 25;
  idx_PresupuestosClienteIVA = 26;
  idx_PresupuestosClienteIMPORTE_IVA = 27;
  idx_PresupuestosClienteIMPORTE_TOTAL = 28;
  idx_PresupuestosClienteID_FORMA_PAGO = 29;
  idx_PresupuestosClienteID_FACTURA = 30;
  idx_PresupuestosClienteFACTURA = 31;
  idx_PresupuestosClientePERSONA_CONTACTO = 32;
  idx_PresupuestosClienteDESCRIPCION_BONIFICACION = 33;
  idx_PresupuestosClienteIMPORTE_BONIFICACION = 34;

  { PresupuestosCliente_Detalles fields }
  fld_PresupuestosCliente_DetallesID = 'ID';
  fld_PresupuestosCliente_DetallesID_PRESUPUESTO = 'ID_PRESUPUESTO';
  fld_PresupuestosCliente_DetallesPOSICION = 'POSICION';
  fld_PresupuestosCliente_DetallesTIPO_DETALLE = 'TIPO_DETALLE';
  fld_PresupuestosCliente_DetallesCONCEPTO = 'CONCEPTO';
  fld_PresupuestosCliente_DetallesCANTIDAD = 'CANTIDAD';
  fld_PresupuestosCliente_DetallesUNIDAD_MEDIDA = 'UNIDAD_MEDIDA';
  fld_PresupuestosCliente_DetallesIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_PresupuestosCliente_DetallesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_PresupuestosCliente_DetallesVISIBLE = 'VISIBLE';
  fld_PresupuestosCliente_DetallesID_ARTICULO = 'ID_ARTICULO';
  fld_PresupuestosCliente_DetallesDESCUENTO = 'DESCUENTO';
  fld_PresupuestosCliente_DetallesIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_PresupuestosCliente_DetallesREFERENCIA = 'REFERENCIA';
  fld_PresupuestosCliente_DetallesREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';

  { PresupuestosCliente_Detalles field indexes }
  idx_PresupuestosCliente_DetallesID = 0;
  idx_PresupuestosCliente_DetallesID_PRESUPUESTO = 1;
  idx_PresupuestosCliente_DetallesPOSICION = 2;
  idx_PresupuestosCliente_DetallesTIPO_DETALLE = 3;
  idx_PresupuestosCliente_DetallesCONCEPTO = 4;
  idx_PresupuestosCliente_DetallesCANTIDAD = 5;
  idx_PresupuestosCliente_DetallesUNIDAD_MEDIDA = 6;
  idx_PresupuestosCliente_DetallesIMPORTE_UNIDAD = 7;
  idx_PresupuestosCliente_DetallesIMPORTE_TOTAL = 8;
  idx_PresupuestosCliente_DetallesVISIBLE = 9;
  idx_PresupuestosCliente_DetallesID_ARTICULO = 10;
  idx_PresupuestosCliente_DetallesDESCUENTO = 11;
  idx_PresupuestosCliente_DetallesIMPORTE_PORTE = 12;
  idx_PresupuestosCliente_DetallesREFERENCIA = 13;
  idx_PresupuestosCliente_DetallesREFERENCIA_PROVEEDOR = 14;

type
  { IListaAnosPresupuestos }
  IListaAnosPresupuestos = interface(IDAStronglyTypedDataTable)
  ['{AA0035CA-BE66-4730-A30B-E09CE7BB0325}']
    { Property getters and setters }
    function GetANOValue: String;
    procedure SetANOValue(const aValue: String);
    function GetANOIsNull: Boolean;
    procedure SetANOIsNull(const aValue: Boolean);


    { Properties }
    property ANO: String read GetANOValue write SetANOValue;
    property ANOIsNull: Boolean read GetANOIsNull write SetANOIsNull;
  end;

  { TListaAnosPresupuestosDataTableRules }
  TListaAnosPresupuestosDataTableRules = class(TIntfObjectDADataTableRules, IListaAnosPresupuestos)
  private
  protected
    { Property getters and setters }
    function GetANOValue: String; virtual;
    procedure SetANOValue(const aValue: String); virtual;
    function GetANOIsNull: Boolean; virtual;
    procedure SetANOIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ANO: String read GetANOValue write SetANOValue;
    property ANOIsNull: Boolean read GetANOIsNull write SetANOIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IPresupuestosCliente }
  IPresupuestosCliente = interface(IDAStronglyTypedDataTable)
  ['{294F97CB-1951-4F11-A7D9-2433A2E0237F}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetFECHA_PRESUPUESTOValue: DateTime;
    procedure SetFECHA_PRESUPUESTOValue(const aValue: DateTime);
    function GetFECHA_PRESUPUESTOIsNull: Boolean;
    procedure SetFECHA_PRESUPUESTOIsNull(const aValue: Boolean);
    function GetFECHA_DECISIONValue: DateTime;
    procedure SetFECHA_DECISIONValue(const aValue: DateTime);
    function GetFECHA_DECISIONIsNull: Boolean;
    procedure SetFECHA_DECISIONIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetREFERENCIA_AUXValue: String;
    procedure SetREFERENCIA_AUXValue(const aValue: String);
    function GetREFERENCIA_AUXIsNull: Boolean;
    procedure SetREFERENCIA_AUXIsNull(const aValue: Boolean);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetSITUACIONIsNull: Boolean;
    procedure SetSITUACIONIsNull(const aValue: Boolean);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetID_CLIENTEIsNull: Boolean;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean);
    function GetID_DIRECCIONValue: Integer;
    procedure SetID_DIRECCIONValue(const aValue: Integer);
    function GetID_DIRECCIONIsNull: Boolean;
    procedure SetID_DIRECCIONIsNull(const aValue: Boolean);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNIF_CIFIsNull: Boolean;
    procedure SetNIF_CIFIsNull(const aValue: Boolean);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOMBREIsNull: Boolean;
    procedure SetNOMBREIsNull(const aValue: Boolean);
    function GetREFERENCIA_CLIENTEValue: String;
    procedure SetREFERENCIA_CLIENTEValue(const aValue: String);
    function GetREFERENCIA_CLIENTEIsNull: Boolean;
    procedure SetREFERENCIA_CLIENTEIsNull(const aValue: Boolean);
    function GetCLIENTE_FINALValue: String;
    procedure SetCLIENTE_FINALValue(const aValue: String);
    function GetCLIENTE_FINALIsNull: Boolean;
    procedure SetCLIENTE_FINALIsNull(const aValue: Boolean);
    function GetPORTADAValue: IROStrings;
    function GetPORTADAIsNull: Boolean;
    procedure SetPORTADAIsNull(const aValue: Boolean);
    function GetMEMORIAValue: IROStrings;
    function GetMEMORIAIsNull: Boolean;
    procedure SetMEMORIAIsNull(const aValue: Boolean);
    function GetOBSERVACIONESValue: IROStrings;
    function GetOBSERVACIONESIsNull: Boolean;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean);
    function GetINCIDENCIASValue: IROStrings;
    function GetINCIDENCIASIsNull: Boolean;
    procedure SetINCIDENCIASIsNull(const aValue: Boolean);
    function GetINCIDENCIAS_ACTIVASValue: Integer;
    procedure SetINCIDENCIAS_ACTIVASValue(const aValue: Integer);
    function GetINCIDENCIAS_ACTIVASIsNull: Boolean;
    procedure SetINCIDENCIAS_ACTIVASIsNull(const aValue: Boolean);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_ALTAIsNull: Boolean;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONIsNull: Boolean;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetUSUARIOIsNull: Boolean;
    procedure SetUSUARIOIsNull(const aValue: Boolean);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_NETOIsNull: Boolean;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIMPORTE_DESCUENTOIsNull: Boolean;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetBASE_IMPONIBLEIsNull: Boolean;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIVAIsNull: Boolean;
    procedure SetIVAIsNull(const aValue: Boolean);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetIMPORTE_IVAIsNull: Boolean;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetID_FORMA_PAGOIsNull: Boolean;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_FACTURAIsNull: Boolean;
    procedure SetID_FACTURAIsNull(const aValue: Boolean);
    function GetFACTURAValue: String;
    procedure SetFACTURAValue(const aValue: String);
    function GetFACTURAIsNull: Boolean;
    procedure SetFACTURAIsNull(const aValue: Boolean);
    function GetPERSONA_CONTACTOValue: String;
    procedure SetPERSONA_CONTACTOValue(const aValue: String);
    function GetPERSONA_CONTACTOIsNull: Boolean;
    procedure SetPERSONA_CONTACTOIsNull(const aValue: Boolean);
    function GetDESCRIPCION_BONIFICACIONValue: String;
    procedure SetDESCRIPCION_BONIFICACIONValue(const aValue: String);
    function GetDESCRIPCION_BONIFICACIONIsNull: Boolean;
    procedure SetDESCRIPCION_BONIFICACIONIsNull(const aValue: Boolean);
    function GetIMPORTE_BONIFICACIONValue: Currency;
    procedure SetIMPORTE_BONIFICACIONValue(const aValue: Currency);
    function GetIMPORTE_BONIFICACIONIsNull: Boolean;
    procedure SetIMPORTE_BONIFICACIONIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property FECHA_PRESUPUESTO: DateTime read GetFECHA_PRESUPUESTOValue write SetFECHA_PRESUPUESTOValue;
    property FECHA_PRESUPUESTOIsNull: Boolean read GetFECHA_PRESUPUESTOIsNull write SetFECHA_PRESUPUESTOIsNull;
    property FECHA_DECISION: DateTime read GetFECHA_DECISIONValue write SetFECHA_DECISIONValue;
    property FECHA_DECISIONIsNull: Boolean read GetFECHA_DECISIONIsNull write SetFECHA_DECISIONIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_AUX: String read GetREFERENCIA_AUXValue write SetREFERENCIA_AUXValue;
    property REFERENCIA_AUXIsNull: Boolean read GetREFERENCIA_AUXIsNull write SetREFERENCIA_AUXIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property ID_DIRECCION: Integer read GetID_DIRECCIONValue write SetID_DIRECCIONValue;
    property ID_DIRECCIONIsNull: Boolean read GetID_DIRECCIONIsNull write SetID_DIRECCIONIsNull;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull: Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property REFERENCIA_CLIENTE: String read GetREFERENCIA_CLIENTEValue write SetREFERENCIA_CLIENTEValue;
    property REFERENCIA_CLIENTEIsNull: Boolean read GetREFERENCIA_CLIENTEIsNull write SetREFERENCIA_CLIENTEIsNull;
    property CLIENTE_FINAL: String read GetCLIENTE_FINALValue write SetCLIENTE_FINALValue;
    property CLIENTE_FINALIsNull: Boolean read GetCLIENTE_FINALIsNull write SetCLIENTE_FINALIsNull;
    property PORTADA: IROStrings read GetPORTADAValue;
    property PORTADAIsNull: Boolean read GetPORTADAIsNull write SetPORTADAIsNull;
    property MEMORIA: IROStrings read GetMEMORIAValue;
    property MEMORIAIsNull: Boolean read GetMEMORIAIsNull write SetMEMORIAIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property INCIDENCIAS: IROStrings read GetINCIDENCIASValue;
    property INCIDENCIASIsNull: Boolean read GetINCIDENCIASIsNull write SetINCIDENCIASIsNull;
    property INCIDENCIAS_ACTIVAS: Integer read GetINCIDENCIAS_ACTIVASValue write SetINCIDENCIAS_ACTIVASValue;
    property INCIDENCIAS_ACTIVASIsNull: Boolean read GetINCIDENCIAS_ACTIVASIsNull write SetINCIDENCIAS_ACTIVASIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property FACTURA: String read GetFACTURAValue write SetFACTURAValue;
    property FACTURAIsNull: Boolean read GetFACTURAIsNull write SetFACTURAIsNull;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property PERSONA_CONTACTOIsNull: Boolean read GetPERSONA_CONTACTOIsNull write SetPERSONA_CONTACTOIsNull;
    property DESCRIPCION_BONIFICACION: String read GetDESCRIPCION_BONIFICACIONValue write SetDESCRIPCION_BONIFICACIONValue;
    property DESCRIPCION_BONIFICACIONIsNull: Boolean read GetDESCRIPCION_BONIFICACIONIsNull write SetDESCRIPCION_BONIFICACIONIsNull;
    property IMPORTE_BONIFICACION: Currency read GetIMPORTE_BONIFICACIONValue write SetIMPORTE_BONIFICACIONValue;
    property IMPORTE_BONIFICACIONIsNull: Boolean read GetIMPORTE_BONIFICACIONIsNull write SetIMPORTE_BONIFICACIONIsNull;
  end;

  { TPresupuestosClienteDataTableRules }
  TPresupuestosClienteDataTableRules = class(TIntfObjectDADataTableRules, IPresupuestosCliente)
  private
    f_PORTADA: IROStrings;
    f_MEMORIA: IROStrings;
    f_OBSERVACIONES: IROStrings;
    f_INCIDENCIAS: IROStrings;
    procedure PORTADA_OnChange(Sender: TObject);
    procedure MEMORIA_OnChange(Sender: TObject);
    procedure OBSERVACIONES_OnChange(Sender: TObject);
    procedure INCIDENCIAS_OnChange(Sender: TObject);
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_PRESUPUESTOValue: DateTime; virtual;
    procedure SetFECHA_PRESUPUESTOValue(const aValue: DateTime); virtual;
    function GetFECHA_PRESUPUESTOIsNull: Boolean; virtual;
    procedure SetFECHA_PRESUPUESTOIsNull(const aValue: Boolean); virtual;
    function GetFECHA_DECISIONValue: DateTime; virtual;
    procedure SetFECHA_DECISIONValue(const aValue: DateTime); virtual;
    function GetFECHA_DECISIONIsNull: Boolean; virtual;
    procedure SetFECHA_DECISIONIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_AUXValue: String; virtual;
    procedure SetREFERENCIA_AUXValue(const aValue: String); virtual;
    function GetREFERENCIA_AUXIsNull: Boolean; virtual;
    procedure SetREFERENCIA_AUXIsNull(const aValue: Boolean); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetSITUACIONIsNull: Boolean; virtual;
    procedure SetSITUACIONIsNull(const aValue: Boolean); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetID_CLIENTEIsNull: Boolean; virtual;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetID_DIRECCIONValue: Integer; virtual;
    procedure SetID_DIRECCIONValue(const aValue: Integer); virtual;
    function GetID_DIRECCIONIsNull: Boolean; virtual;
    procedure SetID_DIRECCIONIsNull(const aValue: Boolean); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNIF_CIFIsNull: Boolean; virtual;
    procedure SetNIF_CIFIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_CLIENTEValue: String; virtual;
    procedure SetREFERENCIA_CLIENTEValue(const aValue: String); virtual;
    function GetREFERENCIA_CLIENTEIsNull: Boolean; virtual;
    procedure SetREFERENCIA_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetCLIENTE_FINALValue: String; virtual;
    procedure SetCLIENTE_FINALValue(const aValue: String); virtual;
    function GetCLIENTE_FINALIsNull: Boolean; virtual;
    procedure SetCLIENTE_FINALIsNull(const aValue: Boolean); virtual;
    function GetPORTADAValue: IROStrings; virtual;
    function GetPORTADAIsNull: Boolean; virtual;
    procedure SetPORTADAIsNull(const aValue: Boolean); virtual;
    function GetMEMORIAValue: IROStrings; virtual;
    function GetMEMORIAIsNull: Boolean; virtual;
    procedure SetMEMORIAIsNull(const aValue: Boolean); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    function GetOBSERVACIONESIsNull: Boolean; virtual;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean); virtual;
    function GetINCIDENCIASValue: IROStrings; virtual;
    function GetINCIDENCIASIsNull: Boolean; virtual;
    procedure SetINCIDENCIASIsNull(const aValue: Boolean); virtual;
    function GetINCIDENCIAS_ACTIVASValue: Integer; virtual;
    procedure SetINCIDENCIAS_ACTIVASValue(const aValue: Integer); virtual;
    function GetINCIDENCIAS_ACTIVASIsNull: Boolean; virtual;
    procedure SetINCIDENCIAS_ACTIVASIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_ALTAIsNull: Boolean; virtual;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONIsNull: Boolean; virtual;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_NETOIsNull: Boolean; virtual;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIMPORTE_DESCUENTOIsNull: Boolean; virtual;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetBASE_IMPONIBLEIsNull: Boolean; virtual;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIVAIsNull: Boolean; virtual;
    procedure SetIVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetIMPORTE_IVAIsNull: Boolean; virtual;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetID_FORMA_PAGOIsNull: Boolean; virtual;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_FACTURAIsNull: Boolean; virtual;
    procedure SetID_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetFACTURAValue: String; virtual;
    procedure SetFACTURAValue(const aValue: String); virtual;
    function GetFACTURAIsNull: Boolean; virtual;
    procedure SetFACTURAIsNull(const aValue: Boolean); virtual;
    function GetPERSONA_CONTACTOValue: String; virtual;
    procedure SetPERSONA_CONTACTOValue(const aValue: String); virtual;
    function GetPERSONA_CONTACTOIsNull: Boolean; virtual;
    procedure SetPERSONA_CONTACTOIsNull(const aValue: Boolean); virtual;
    function GetDESCRIPCION_BONIFICACIONValue: String; virtual;
    procedure SetDESCRIPCION_BONIFICACIONValue(const aValue: String); virtual;
    function GetDESCRIPCION_BONIFICACIONIsNull: Boolean; virtual;
    procedure SetDESCRIPCION_BONIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_BONIFICACIONValue: Currency; virtual;
    procedure SetIMPORTE_BONIFICACIONValue(const aValue: Currency); virtual;
    function GetIMPORTE_BONIFICACIONIsNull: Boolean; virtual;
    procedure SetIMPORTE_BONIFICACIONIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property FECHA_PRESUPUESTO: DateTime read GetFECHA_PRESUPUESTOValue write SetFECHA_PRESUPUESTOValue;
    property FECHA_PRESUPUESTOIsNull: Boolean read GetFECHA_PRESUPUESTOIsNull write SetFECHA_PRESUPUESTOIsNull;
    property FECHA_DECISION: DateTime read GetFECHA_DECISIONValue write SetFECHA_DECISIONValue;
    property FECHA_DECISIONIsNull: Boolean read GetFECHA_DECISIONIsNull write SetFECHA_DECISIONIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_AUX: String read GetREFERENCIA_AUXValue write SetREFERENCIA_AUXValue;
    property REFERENCIA_AUXIsNull: Boolean read GetREFERENCIA_AUXIsNull write SetREFERENCIA_AUXIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property ID_DIRECCION: Integer read GetID_DIRECCIONValue write SetID_DIRECCIONValue;
    property ID_DIRECCIONIsNull: Boolean read GetID_DIRECCIONIsNull write SetID_DIRECCIONIsNull;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull: Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property REFERENCIA_CLIENTE: String read GetREFERENCIA_CLIENTEValue write SetREFERENCIA_CLIENTEValue;
    property REFERENCIA_CLIENTEIsNull: Boolean read GetREFERENCIA_CLIENTEIsNull write SetREFERENCIA_CLIENTEIsNull;
    property CLIENTE_FINAL: String read GetCLIENTE_FINALValue write SetCLIENTE_FINALValue;
    property CLIENTE_FINALIsNull: Boolean read GetCLIENTE_FINALIsNull write SetCLIENTE_FINALIsNull;
    property PORTADA: IROStrings read GetPORTADAValue;
    property PORTADAIsNull: Boolean read GetPORTADAIsNull write SetPORTADAIsNull;
    property MEMORIA: IROStrings read GetMEMORIAValue;
    property MEMORIAIsNull: Boolean read GetMEMORIAIsNull write SetMEMORIAIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property INCIDENCIAS: IROStrings read GetINCIDENCIASValue;
    property INCIDENCIASIsNull: Boolean read GetINCIDENCIASIsNull write SetINCIDENCIASIsNull;
    property INCIDENCIAS_ACTIVAS: Integer read GetINCIDENCIAS_ACTIVASValue write SetINCIDENCIAS_ACTIVASValue;
    property INCIDENCIAS_ACTIVASIsNull: Boolean read GetINCIDENCIAS_ACTIVASIsNull write SetINCIDENCIAS_ACTIVASIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property FACTURA: String read GetFACTURAValue write SetFACTURAValue;
    property FACTURAIsNull: Boolean read GetFACTURAIsNull write SetFACTURAIsNull;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property PERSONA_CONTACTOIsNull: Boolean read GetPERSONA_CONTACTOIsNull write SetPERSONA_CONTACTOIsNull;
    property DESCRIPCION_BONIFICACION: String read GetDESCRIPCION_BONIFICACIONValue write SetDESCRIPCION_BONIFICACIONValue;
    property DESCRIPCION_BONIFICACIONIsNull: Boolean read GetDESCRIPCION_BONIFICACIONIsNull write SetDESCRIPCION_BONIFICACIONIsNull;
    property IMPORTE_BONIFICACION: Currency read GetIMPORTE_BONIFICACIONValue write SetIMPORTE_BONIFICACIONValue;
    property IMPORTE_BONIFICACIONIsNull: Boolean read GetIMPORTE_BONIFICACIONIsNull write SetIMPORTE_BONIFICACIONIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IPresupuestosCliente_Detalles }
  IPresupuestosCliente_Detalles = interface(IDAStronglyTypedDataTable)
  ['{6E73582D-E1A0-40EA-A96A-1993F55F76A8}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_PRESUPUESTOValue: Integer;
    procedure SetID_PRESUPUESTOValue(const aValue: Integer);
    function GetID_PRESUPUESTOIsNull: Boolean;
    procedure SetID_PRESUPUESTOIsNull(const aValue: Boolean);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetPOSICIONIsNull: Boolean;
    procedure SetPOSICIONIsNull(const aValue: Boolean);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetTIPO_DETALLEIsNull: Boolean;
    procedure SetTIPO_DETALLEIsNull(const aValue: Boolean);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCONCEPTOIsNull: Boolean;
    procedure SetCONCEPTOIsNull(const aValue: Boolean);
    function GetCANTIDADValue: Float;
    procedure SetCANTIDADValue(const aValue: Float);
    function GetCANTIDADIsNull: Boolean;
    procedure SetCANTIDADIsNull(const aValue: Boolean);
    function GetUNIDAD_MEDIDAValue: String;
    procedure SetUNIDAD_MEDIDAValue(const aValue: String);
    function GetUNIDAD_MEDIDAIsNull: Boolean;
    procedure SetUNIDAD_MEDIDAIsNull(const aValue: Boolean);
    function GetIMPORTE_UNIDADValue: Currency;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency);
    function GetIMPORTE_UNIDADIsNull: Boolean;
    procedure SetIMPORTE_UNIDADIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetVISIBLEValue: Integer;
    procedure SetVISIBLEValue(const aValue: Integer);
    function GetVISIBLEIsNull: Boolean;
    procedure SetVISIBLEIsNull(const aValue: Boolean);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetID_ARTICULOIsNull: Boolean;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORIsNull: Boolean;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_PRESUPUESTO: Integer read GetID_PRESUPUESTOValue write SetID_PRESUPUESTOValue;
    property ID_PRESUPUESTOIsNull: Boolean read GetID_PRESUPUESTOIsNull write SetID_PRESUPUESTOIsNull;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property POSICIONIsNull: Boolean read GetPOSICIONIsNull write SetPOSICIONIsNull;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property TIPO_DETALLEIsNull: Boolean read GetTIPO_DETALLEIsNull write SetTIPO_DETALLEIsNull;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CONCEPTOIsNull: Boolean read GetCONCEPTOIsNull write SetCONCEPTOIsNull;
    property CANTIDAD: Float read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property UNIDAD_MEDIDA: String read GetUNIDAD_MEDIDAValue write SetUNIDAD_MEDIDAValue;
    property UNIDAD_MEDIDAIsNull: Boolean read GetUNIDAD_MEDIDAIsNull write SetUNIDAD_MEDIDAIsNull;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_UNIDADIsNull: Boolean read GetIMPORTE_UNIDADIsNull write SetIMPORTE_UNIDADIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property VISIBLEIsNull: Boolean read GetVISIBLEIsNull write SetVISIBLEIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
  end;

  { TPresupuestosCliente_DetallesDataTableRules }
  TPresupuestosCliente_DetallesDataTableRules = class(TIntfObjectDADataTableRules, IPresupuestosCliente_Detalles)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_PRESUPUESTOValue: Integer; virtual;
    procedure SetID_PRESUPUESTOValue(const aValue: Integer); virtual;
    function GetID_PRESUPUESTOIsNull: Boolean; virtual;
    procedure SetID_PRESUPUESTOIsNull(const aValue: Boolean); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetPOSICIONIsNull: Boolean; virtual;
    procedure SetPOSICIONIsNull(const aValue: Boolean); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetTIPO_DETALLEIsNull: Boolean; virtual;
    procedure SetTIPO_DETALLEIsNull(const aValue: Boolean); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCONCEPTOIsNull: Boolean; virtual;
    procedure SetCONCEPTOIsNull(const aValue: Boolean); virtual;
    function GetCANTIDADValue: Float; virtual;
    procedure SetCANTIDADValue(const aValue: Float); virtual;
    function GetCANTIDADIsNull: Boolean; virtual;
    procedure SetCANTIDADIsNull(const aValue: Boolean); virtual;
    function GetUNIDAD_MEDIDAValue: String; virtual;
    procedure SetUNIDAD_MEDIDAValue(const aValue: String); virtual;
    function GetUNIDAD_MEDIDAIsNull: Boolean; virtual;
    procedure SetUNIDAD_MEDIDAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_UNIDADValue: Currency; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency); virtual;
    function GetIMPORTE_UNIDADIsNull: Boolean; virtual;
    procedure SetIMPORTE_UNIDADIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetVISIBLEValue: Integer; virtual;
    procedure SetVISIBLEValue(const aValue: Integer); virtual;
    function GetVISIBLEIsNull: Boolean; virtual;
    procedure SetVISIBLEIsNull(const aValue: Boolean); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetID_ARTICULOIsNull: Boolean; virtual;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORIsNull: Boolean; virtual;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_PRESUPUESTO: Integer read GetID_PRESUPUESTOValue write SetID_PRESUPUESTOValue;
    property ID_PRESUPUESTOIsNull: Boolean read GetID_PRESUPUESTOIsNull write SetID_PRESUPUESTOIsNull;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property POSICIONIsNull: Boolean read GetPOSICIONIsNull write SetPOSICIONIsNull;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property TIPO_DETALLEIsNull: Boolean read GetTIPO_DETALLEIsNull write SetTIPO_DETALLEIsNull;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CONCEPTOIsNull: Boolean read GetCONCEPTOIsNull write SetCONCEPTOIsNull;
    property CANTIDAD: Float read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property UNIDAD_MEDIDA: String read GetUNIDAD_MEDIDAValue write SetUNIDAD_MEDIDAValue;
    property UNIDAD_MEDIDAIsNull: Boolean read GetUNIDAD_MEDIDAIsNull write SetUNIDAD_MEDIDAIsNull;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_UNIDADIsNull: Boolean read GetIMPORTE_UNIDADIsNull write SetIMPORTE_UNIDADIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property VISIBLEIsNull: Boolean read GetVISIBLEIsNull write SetVISIBLEIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TListaAnosPresupuestosDataTableRules }
constructor TListaAnosPresupuestosDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TListaAnosPresupuestosDataTableRules.Destroy;
begin
  inherited;
end;

function TListaAnosPresupuestosDataTableRules.GetANOValue: String;
begin
  result := DataTable.Fields[idx_ListaAnosPresupuestosANO].AsString;
end;

procedure TListaAnosPresupuestosDataTableRules.SetANOValue(const aValue: String);
begin
  DataTable.Fields[idx_ListaAnosPresupuestosANO].AsString := aValue;
end;

function TListaAnosPresupuestosDataTableRules.GetANOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ListaAnosPresupuestosANO].IsNull;
end;

procedure TListaAnosPresupuestosDataTableRules.SetANOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ListaAnosPresupuestosANO].AsVariant := Null;
end;


{ TPresupuestosClienteDataTableRules }
constructor TPresupuestosClienteDataTableRules.Create(aDataTable: TDADataTable);
var
  StrList: TStringList;
begin
  inherited;

  StrList := TStringList.Create;
  StrList.OnChange := PORTADA_OnChange;
  f_PORTADA := NewROStrings(StrList,True);

  StrList := TStringList.Create;
  StrList.OnChange := MEMORIA_OnChange;
  f_MEMORIA := NewROStrings(StrList,True);

  StrList := TStringList.Create;
  StrList.OnChange := OBSERVACIONES_OnChange;
  f_OBSERVACIONES := NewROStrings(StrList,True);

  StrList := TStringList.Create;
  StrList.OnChange := INCIDENCIAS_OnChange;
  f_INCIDENCIAS := NewROStrings(StrList,True);
end;

destructor TPresupuestosClienteDataTableRules.Destroy;
begin
  inherited;
end;

procedure TPresupuestosClienteDataTableRules.PORTADA_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_PresupuestosClientePORTADA].AsVariant := TStringList(Sender).Text;
end;

procedure TPresupuestosClienteDataTableRules.MEMORIA_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_PresupuestosClienteMEMORIA].AsVariant := TStringList(Sender).Text;
end;

procedure TPresupuestosClienteDataTableRules.OBSERVACIONES_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_PresupuestosClienteOBSERVACIONES].AsVariant := TStringList(Sender).Text;
end;

procedure TPresupuestosClienteDataTableRules.INCIDENCIAS_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_PresupuestosClienteINCIDENCIAS].AsVariant := TStringList(Sender).Text;
end;

function TPresupuestosClienteDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID].AsInteger;
end;

procedure TPresupuestosClienteDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosClienteID].AsInteger := aValue;
end;

function TPresupuestosClienteDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteID].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_EMPRESA].AsInteger;
end;

procedure TPresupuestosClienteDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosClienteID_EMPRESA].AsInteger := aValue;
end;

function TPresupuestosClienteDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_EMPRESA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteID_EMPRESA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetFECHA_PRESUPUESTOValue: DateTime;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFECHA_PRESUPUESTO].AsDateTime;
end;

procedure TPresupuestosClienteDataTableRules.SetFECHA_PRESUPUESTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_PresupuestosClienteFECHA_PRESUPUESTO].AsDateTime := aValue;
end;

function TPresupuestosClienteDataTableRules.GetFECHA_PRESUPUESTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFECHA_PRESUPUESTO].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetFECHA_PRESUPUESTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteFECHA_PRESUPUESTO].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetFECHA_DECISIONValue: DateTime;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFECHA_DECISION].AsDateTime;
end;

procedure TPresupuestosClienteDataTableRules.SetFECHA_DECISIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_PresupuestosClienteFECHA_DECISION].AsDateTime := aValue;
end;

function TPresupuestosClienteDataTableRules.GetFECHA_DECISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFECHA_DECISION].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetFECHA_DECISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteFECHA_DECISION].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteREFERENCIA].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteREFERENCIA].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteREFERENCIA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteREFERENCIA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetREFERENCIA_AUXValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteREFERENCIA_AUX].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetREFERENCIA_AUXValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteREFERENCIA_AUX].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetREFERENCIA_AUXIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteREFERENCIA_AUX].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetREFERENCIA_AUXIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteREFERENCIA_AUX].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteSITUACION].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteSITUACION].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetSITUACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteSITUACION].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetSITUACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteSITUACION].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_CLIENTE].AsInteger;
end;

procedure TPresupuestosClienteDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosClienteID_CLIENTE].AsInteger := aValue;
end;

function TPresupuestosClienteDataTableRules.GetID_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_CLIENTE].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetID_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteID_CLIENTE].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetID_DIRECCIONValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_DIRECCION].AsInteger;
end;

procedure TPresupuestosClienteDataTableRules.SetID_DIRECCIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosClienteID_DIRECCION].AsInteger := aValue;
end;

function TPresupuestosClienteDataTableRules.GetID_DIRECCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_DIRECCION].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetID_DIRECCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteID_DIRECCION].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteNIF_CIF].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteNIF_CIF].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetNIF_CIFIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteNIF_CIF].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetNIF_CIFIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteNIF_CIF].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteNOMBRE].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteNOMBRE].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetNOMBREIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteNOMBRE].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteNOMBRE].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetREFERENCIA_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteREFERENCIA_CLIENTE].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetREFERENCIA_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteREFERENCIA_CLIENTE].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetREFERENCIA_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteREFERENCIA_CLIENTE].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetREFERENCIA_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteREFERENCIA_CLIENTE].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetCLIENTE_FINALValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteCLIENTE_FINAL].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetCLIENTE_FINALValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteCLIENTE_FINAL].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetCLIENTE_FINALIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteCLIENTE_FINAL].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetCLIENTE_FINALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteCLIENTE_FINAL].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetPORTADAValue: IROStrings;
begin
  result := f_PORTADA;
  result.Text := DataTable.Fields[idx_PresupuestosClientePORTADA].AsString;
end;

function TPresupuestosClienteDataTableRules.GetPORTADAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClientePORTADA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetPORTADAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClientePORTADA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetMEMORIAValue: IROStrings;
begin
  result := f_MEMORIA;
  result.Text := DataTable.Fields[idx_PresupuestosClienteMEMORIA].AsString;
end;

function TPresupuestosClienteDataTableRules.GetMEMORIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteMEMORIA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetMEMORIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteMEMORIA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := f_OBSERVACIONES;
  result.Text := DataTable.Fields[idx_PresupuestosClienteOBSERVACIONES].AsString;
end;

function TPresupuestosClienteDataTableRules.GetOBSERVACIONESIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteOBSERVACIONES].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetOBSERVACIONESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteOBSERVACIONES].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetINCIDENCIASValue: IROStrings;
begin
  result := f_INCIDENCIAS;
  result.Text := DataTable.Fields[idx_PresupuestosClienteINCIDENCIAS].AsString;
end;

function TPresupuestosClienteDataTableRules.GetINCIDENCIASIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteINCIDENCIAS].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetINCIDENCIASIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteINCIDENCIAS].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetINCIDENCIAS_ACTIVASValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosClienteINCIDENCIAS_ACTIVAS].AsInteger;
end;

procedure TPresupuestosClienteDataTableRules.SetINCIDENCIAS_ACTIVASValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosClienteINCIDENCIAS_ACTIVAS].AsInteger := aValue;
end;

function TPresupuestosClienteDataTableRules.GetINCIDENCIAS_ACTIVASIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteINCIDENCIAS_ACTIVAS].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetINCIDENCIAS_ACTIVASIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteINCIDENCIAS_ACTIVAS].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFECHA_ALTA].AsDateTime;
end;

procedure TPresupuestosClienteDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_PresupuestosClienteFECHA_ALTA].AsDateTime := aValue;
end;

function TPresupuestosClienteDataTableRules.GetFECHA_ALTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFECHA_ALTA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetFECHA_ALTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteFECHA_ALTA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFECHA_MODIFICACION].AsDateTime;
end;

procedure TPresupuestosClienteDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_PresupuestosClienteFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TPresupuestosClienteDataTableRules.GetFECHA_MODIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFECHA_MODIFICACION].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteFECHA_MODIFICACION].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteUSUARIO].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteUSUARIO].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetUSUARIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteUSUARIO].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteUSUARIO].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_NETO].AsCurrency;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosClienteIMPORTE_NETO].AsCurrency := aValue;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_NETOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_NETO].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_NETOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteIMPORTE_NETO].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_PORTE].AsCurrency;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosClienteIMPORTE_PORTE].AsCurrency := aValue;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_PORTE].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteIMPORTE_PORTE].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_PresupuestosClienteDESCUENTO].AsFloat;
end;

procedure TPresupuestosClienteDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_PresupuestosClienteDESCUENTO].AsFloat := aValue;
end;

function TPresupuestosClienteDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteDESCUENTO].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteDESCUENTO].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosClienteIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_DESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_DESCUENTO].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteIMPORTE_DESCUENTO].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosClienteBASE_IMPONIBLE].AsCurrency;
end;

procedure TPresupuestosClienteDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosClienteBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TPresupuestosClienteDataTableRules.GetBASE_IMPONIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteBASE_IMPONIBLE].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteBASE_IMPONIBLE].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIVA].AsFloat;
end;

procedure TPresupuestosClienteDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_PresupuestosClienteIVA].AsFloat := aValue;
end;

function TPresupuestosClienteDataTableRules.GetIVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIVA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetIVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteIVA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_IVA].AsCurrency;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosClienteIMPORTE_IVA].AsCurrency := aValue;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_IVA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteIMPORTE_IVA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_TOTAL].AsCurrency;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosClienteIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_TOTAL].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteIMPORTE_TOTAL].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_FORMA_PAGO].AsInteger;
end;

procedure TPresupuestosClienteDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosClienteID_FORMA_PAGO].AsInteger := aValue;
end;

function TPresupuestosClienteDataTableRules.GetID_FORMA_PAGOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_FORMA_PAGO].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetID_FORMA_PAGOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteID_FORMA_PAGO].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_FACTURA].AsInteger;
end;

procedure TPresupuestosClienteDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosClienteID_FACTURA].AsInteger := aValue;
end;

function TPresupuestosClienteDataTableRules.GetID_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteID_FACTURA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetID_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteID_FACTURA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetFACTURAValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFACTURA].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetFACTURAValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteFACTURA].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetFACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteFACTURA].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetFACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteFACTURA].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetPERSONA_CONTACTOValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClientePERSONA_CONTACTO].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetPERSONA_CONTACTOValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClientePERSONA_CONTACTO].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetPERSONA_CONTACTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClientePERSONA_CONTACTO].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetPERSONA_CONTACTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClientePERSONA_CONTACTO].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetDESCRIPCION_BONIFICACIONValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosClienteDESCRIPCION_BONIFICACION].AsString;
end;

procedure TPresupuestosClienteDataTableRules.SetDESCRIPCION_BONIFICACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosClienteDESCRIPCION_BONIFICACION].AsString := aValue;
end;

function TPresupuestosClienteDataTableRules.GetDESCRIPCION_BONIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteDESCRIPCION_BONIFICACION].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetDESCRIPCION_BONIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteDESCRIPCION_BONIFICACION].AsVariant := Null;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_BONIFICACIONValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_BONIFICACION].AsCurrency;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_BONIFICACIONValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosClienteIMPORTE_BONIFICACION].AsCurrency := aValue;
end;

function TPresupuestosClienteDataTableRules.GetIMPORTE_BONIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosClienteIMPORTE_BONIFICACION].IsNull;
end;

procedure TPresupuestosClienteDataTableRules.SetIMPORTE_BONIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosClienteIMPORTE_BONIFICACION].AsVariant := Null;
end;


{ TPresupuestosCliente_DetallesDataTableRules }
constructor TPresupuestosCliente_DetallesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TPresupuestosCliente_DetallesDataTableRules.Destroy;
begin
  inherited;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesID].AsInteger;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesID].AsInteger := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesID].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesID].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetID_PRESUPUESTOValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesID_PRESUPUESTO].AsInteger;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetID_PRESUPUESTOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesID_PRESUPUESTO].AsInteger := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetID_PRESUPUESTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesID_PRESUPUESTO].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetID_PRESUPUESTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesID_PRESUPUESTO].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesPOSICION].AsInteger;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesPOSICION].AsInteger := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetPOSICIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesPOSICION].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetPOSICIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesPOSICION].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesTIPO_DETALLE].AsString;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesTIPO_DETALLE].AsString := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetTIPO_DETALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesTIPO_DETALLE].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetTIPO_DETALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesTIPO_DETALLE].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesCONCEPTO].AsString;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesCONCEPTO].AsString := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetCONCEPTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesCONCEPTO].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetCONCEPTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesCONCEPTO].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetCANTIDADValue: Float;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesCANTIDAD].AsFloat;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetCANTIDADValue(const aValue: Float);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesCANTIDAD].AsFloat := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetCANTIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesCANTIDAD].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetCANTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesCANTIDAD].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetUNIDAD_MEDIDAValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesUNIDAD_MEDIDA].AsString;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetUNIDAD_MEDIDAValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesUNIDAD_MEDIDA].AsString := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetUNIDAD_MEDIDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesUNIDAD_MEDIDA].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetUNIDAD_MEDIDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesUNIDAD_MEDIDA].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetIMPORTE_UNIDADValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_UNIDAD].AsCurrency;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_UNIDAD].AsCurrency := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetIMPORTE_UNIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_UNIDAD].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetIMPORTE_UNIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_UNIDAD].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_TOTAL].AsCurrency;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_TOTAL].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_TOTAL].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetVISIBLEValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesVISIBLE].AsInteger;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetVISIBLEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesVISIBLE].AsInteger := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetVISIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesVISIBLE].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetVISIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesVISIBLE].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesID_ARTICULO].AsInteger;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesID_ARTICULO].AsInteger := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetID_ARTICULOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesID_ARTICULO].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetID_ARTICULOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesID_ARTICULO].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesDESCUENTO].AsFloat;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesDESCUENTO].AsFloat := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesDESCUENTO].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesDESCUENTO].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_PORTE].AsCurrency;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_PORTE].AsCurrency := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_PORTE].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesIMPORTE_PORTE].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesREFERENCIA].AsString;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesREFERENCIA].AsString := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesREFERENCIA].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesREFERENCIA].AsVariant := Null;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesREFERENCIA_PROVEEDOR].AsString;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_PresupuestosCliente_DetallesREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TPresupuestosCliente_DetallesDataTableRules.GetREFERENCIA_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_PresupuestosCliente_DetallesREFERENCIA_PROVEEDOR].IsNull;
end;

procedure TPresupuestosCliente_DetallesDataTableRules.SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_PresupuestosCliente_DetallesREFERENCIA_PROVEEDOR].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_ListaAnosPresupuestos, TListaAnosPresupuestosDataTableRules);
  RegisterDataTableRules(RID_PresupuestosCliente, TPresupuestosClienteDataTableRules);
  RegisterDataTableRules(RID_PresupuestosCliente_Detalles, TPresupuestosCliente_DetallesDataTableRules);

end.
